/***************************************************************************
 *  The FreeMedForms project is a set of free, open source medical         *
 *  applications.                                                          *
 *  (C) 2008-2012 by Eric MAEKER, MD (France) <eric.maeker@gmail.com>      *
 *  All rights reserved.                                                   *
 *                                                                         *
 *  The FreeAccount plugins are free, open source FreeMedForms' plugins.   *
 *  (C) 2010-2011 by Pierre-Marie Desombre, MD <pm.desombre@medsyn.fr>     *
 *  and Eric Maeker, MD <eric.maeker@gmail.com>                            *
 *  All rights reserved.                                                   *
 *                                                                         *
 *  This program is free software: you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation, either version 3 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program (COPYING.FREEMEDFORMS file).                   *
 *  If not, see <http://www.gnu.org/licenses/>.                            *
 ***************************************************************************/
/***************************************************************************
 *  Main Developers : Pierre-Marie DESOMBRE <pm.desombre@medsyn.fr>,      *
 *                     Eric MAEKER, <eric.maeker@gmail.com>                *
 *  Contributors :                                                         *
 *      NAME <MAIL@ADDRESS.COM>                                            *
 ***************************************************************************/
#ifndef ACCOUNTMODE_H
#define ACCOUNTMODE_H

#include <coreplugin/modemanager/basemode.h>

#include <QStackedWidget>

namespace Account {
namespace Internal {

class AccountMode : public Core::BaseMode
{
    Q_OBJECT
public:
    explicit AccountMode(QObject *parent = 0);
    ~AccountMode();
    void setCentralWidget(QWidget *widget);
    
    QString name() const;

public Q_SLOTS:
    void showAddReceipts();
    void showReceipts();
    void showLedger();
    void showMovements();
    void showAssets();
    void showAccount();

private Q_SLOTS:
    void postCoreInitialization();
    void modeActivated(Core::IMode *mode);

private:
    QStackedWidget *m_Stack;
};

}  // End namespace Internal
}  // End namespace Account

#endif // ACCOUNTMODE_H
